#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "pmode.H"
#include "SVGA.H"

#define MAPSIZE 512
#define VIS_START 20
#define VIS_END 55
#define TINYMAPSIZE 80

struct bod
{
        int X;
        int Y;
        short int color;
};

char S[255];
int horizont[2*1024];

SV_palette pal[256];
int sin[360];
int cos[360];

int page=0;
int quit=0;
int DoWait=1;
int DebugPal=0;
int Key;

int POZADI= 0xff;

short int dx,dy,buttons;

int map_x=256;
int map_y=256;
int uhel=180;
int heigth=600;

long int frames = 0;
int initclocks;
int fps;

int thurst=0;
int d_uhel=0;

SV_devCtx       *DC;

char *mapa;
short int *colors;

int pos[2*128];
struct bod data[2*4096];
int MulTab[600];

void _cdecl line(int X1, int Y1, int X2, int Y2, char Color);
void _cdecl lineH(void * horizont, int X1, int Y1, int X2, int Y2, int Color);
void _cdecl skyline(void * horizont, int X, int Y, int Color);
void _cdecl getmouse(short int * , short int * , short int * );
void _cdecl paintmap(char * mapa,int X0, int Y0, int Sirka, int Vyska);
void _cdecl WaitVRT();

void _cdecl VBE_fatalError(char *msg)
{
    printf("FATAL ERROR: %s",msg);
}

void loadtables(void)
{ 
 FILE *siny, *cosiny;

 siny=fopen("sin.tab","rb");
 cosiny=fopen("cos.tab","rb");

 fread(sin,sizeof(sin),1,siny);
 fread(cos,sizeof(cos),1,cosiny);

 fclose(siny);
 fclose(cosiny);
}

void paint(int xp, int yp, int dir,int pg)
{
 
 int z,zobs,ix,iy,iy1,iyp,ixp,x,y,csf,snf,mpc;
 int pozice=0;
 int radek=0;
 
 
 zobs = 300 + mapa[((yp << 9) + xp)&0x3FFF];
 if (zobs<=heigth) zobs = heigth;

   csf = cos[dir]; snf = sin[dir];
  
  for (iy = yp+VIS_START; iy < yp+VIS_END; iy++)
  {
    iy1 = 1 + ((iy - yp) << 1);
    pos[(pg<<7)+radek++]=pozice;
    
    for (ix = xp+((yp-iy)>>1) -1; ix <= xp-((yp-iy)>>1) +1; ix++)
    {
      ixp = xp + (((ix-xp)*csf + (iy-yp)*snf) >> 8);
      iyp = yp + (((iy-yp)*csf - (ix-xp)*snf) >> 8);
      x = 200 + 740 * (ix-xp) / iy1;
      z = mapa[((iyp << 9) + ixp)&0x3FFFF];
      mpc = z;
      if (z<125) z = 125;
      y = 10 + ((zobs-z) * 100) / iy1;

      data[(pg<<12)+pozice].X = x;
      data[(pg<<12)+pozice].Y = y;
      data[(pg<<12)+pozice].color = colors[((iyp << 9) + ixp)&0x3FFFF];
      pozice++;
    };
  };

 pos[(pg<<7)+radek++]=pozice;
}; 

void bar(int X1,int Y1,int X2,int Y2,long Color)
{
int c;

    for(c=Y1;c<Y2;c++)
    {
        SV_line(X1,c,X2,c,Color);
    };
};

void rectangle(int X1,int Y1,int X2,int Y2,long Color)
{
    SV_line(X1,Y1,X2,Y1,Color);
    SV_line(X1,Y1,X1,Y2,Color);
    SV_line(X2,Y1,X2,Y2,Color);
    SV_line(X1,Y2,X2,Y2,Color);
};

int random (int Limit)
{
    return (rand()*Limit/32768);
};
    
int GetHeigth (int mc, int n, int dvd)
{
    int loc;
    
    loc = (mc+n-random(n<<1)) / dvd;

    if (loc>250) loc = 250;
    if (loc<5) loc = 5;
    return loc;
}    
    
void plasma (int X1, int Y1, int X2, int Y2)
{
int Xc, Yc, dxy;
char C1, C2, C3, C4;

    if ((X2-X1<2) && (Y2-Y1<2)) return;

    C1 = mapa[MAPSIZE * Y1 + X1];
    C2 = mapa[MAPSIZE * Y2 + X1];
    C3 = mapa[MAPSIZE * Y1 + X2];
    C4 = mapa[MAPSIZE * Y2 + X2];
    Xc = (X1 + X2) >> 1;
    Yc = (Y1 + Y2) >> 1;
    dxy = 5 * (X2 - X1 + Y2 - Y1) /3;

    if (mapa[MAPSIZE * Y1 + Xc] == 0) mapa[MAPSIZE * Y1 + Xc] = GetHeigth(C1 + C3,dxy,2);
    if (mapa[MAPSIZE * Yc + X1] == 0) mapa[MAPSIZE * Yc + X1] = GetHeigth(C1 + C2,dxy,2);
    if (mapa[MAPSIZE * Yc + X2] == 0) mapa[MAPSIZE * Yc + X2] = GetHeigth(C3 + C4,dxy,2);
    if (mapa[MAPSIZE * Y2 + Xc] == 0) mapa[MAPSIZE * Y2 + Xc] = GetHeigth(C2 + C4,dxy,2);
    mapa[MAPSIZE * Yc + Xc] = GetHeigth(C1 + C2 + C3 + C4,dxy,4);

    plasma(X1,Y1,Xc,Yc);
    plasma(Xc,Y1,X2,Yc);
    plasma(X1,Yc,Xc,Y2);
    plasma(Xc,Yc,X2,Y2);
}

void putbuffer(int pg)
{
int i,j,k,limit,c,t;


 for (i=0;i<VIS_END-VIS_START-1;i++)
 {
   j=pos[(pg<<7)+i];
   k=pos[(pg<<7)+i+1];
   limit=k-1;
   if(i%2==0) k++;
   t=j;

   for(c=0;c<limit-t;c++)       
   {
     lineH(&horizont[pg<<10],data[(pg<<12)+j].X, data[(pg<<12)+j].Y, data[(pg<<12)+k].X, data[(pg<<12)+k].Y, data[(pg<<12)+k].color);
     lineH(&horizont[pg<<10],data[(pg<<12)+j+1].X, data[(pg<<12)+j+1].Y, data[(pg<<12)+k].X, data[(pg<<12)+k].Y,data[(pg<<12)+k].color);
     j++;                                                              //
     k++;
   };

   j=pos[(pg<<7)+i];
   k=pos[(pg<<7)+i+1];
   limit=k-1;
   if(i%2==0) k++;
   t=j;

   for(c=j;c<limit;c++) 
   {
     lineH(&horizont[pg<<10],data[(pg<<12)+k].X, data[(pg<<12)+k].Y, data[(pg<<12)+k+1].X, data[(pg<<12)+k+1].Y,data[(pg<<12)+k].color);
     j++;                                                                                  //
     k++;
   };
 };
};

void paintsky(int * hor)
{

int C;
int min=1600;
int jas=128;

 if(DebugPal) return ;

 for(C=0;C<400;C++)
 {
     if(hor[C]<min) min=hor[C];
 };
 
 for (C=0;C<TINYMAPSIZE;C++) 
 {
   SV_putPixel(TINYMAPSIZE+1,C,0x7F-0xA);
   SV_putPixel(TINYMAPSIZE+2,C,jas);
   if (!(C & 0x7)) jas++;
 };

 for (C=TINYMAPSIZE;C<min;C++) 
 {
   SV_putPixel(2,C,0x7F-0xA);
  SV_putPixel(3,C,jas);
  if(C<200){if (!(C & 0x7)) jas++;}
  
 };

 for (C=1;C<400;C++)
  skyline(hor,C,min,0xf771);//////////////////////////////////////////////////////////////////////obrys
};

void posun(int old_x, int old_y, int uhel, int thurst, int *new_x, int * new_y)
{
     *new_x = old_x + ((sin[uhel>>4]*-thurst) >> 8);
     *new_y = old_y + ((cos[uhel>>4]*-thurst) >> 8);

     *new_x=*new_x%8192;
     *new_y=*new_y%8192;

     if (*new_x<0) new_x+=8192;
     if (*new_y<0) new_y+=8192;

};

void makecolors(void)
{
int C;

 for(C=0;C<MAPSIZE*MAPSIZE;C++)
 {
   if (mapa[C]<125)     colors[C]=(0x00+((mapa[C]*32/125)<<2)); //more
   else
   if (mapa[C]<200)     colors[C]=(0x02+(((200-mapa[C])*32/75)<<8)+(((mapa[C]-125)*8/75)<<13)); ///hory
   else
                        colors[C]=(0x03+(((mapa[C]-200)*32/55)<<8)+(((mapa[C]-200)*32/55)<<2));
 };
};

void setsimpalette(void)
{
 int C;

 for(C=0;C<32;C++)
 {
        pal[C].red=0;
        pal[C].green=0;
        pal[C].blue=128+(C<<1);
 };

 for(C=32;C<55;C++)
 {
        pal[C].red=0;
        pal[C].green=100+((C-32)<<2);
        pal[C].blue=0;
 };

 for(C=55;C<63;C++)
 {
        pal[C].red=100+((C-55)<<4);
        pal[C].green=100+((C-55)<<4);
        pal[C].blue=0;
 };
        pal[63].red=255;
        pal[63].green=255;
        pal[63].blue=255;
 
 for(C=0;C<256;C++)//////////////////
 {
        pal[C].red=0;
        pal[C].green=0;
        pal[C].blue=0;
 };
 SV_setPalette(0,256,pal,-1);
};

void setdebugpalette(void)
{
 int C;

 for(C=0;C<32;C++)
 {
        pal[C].red=0;
        pal[C].green=0;
        pal[C].blue=128+(C<<1);
 };

 for(C=32;C<55;C++)
 {
        pal[C].red=0;
        pal[C].green=100+((C-32)<<2);
        pal[C].blue=0;
 };

 for(C=55;C<63;C++)
 {
        pal[C].red=100+((C-55)<<4);
        pal[C].green=100+((C-55)<<4);
        pal[C].blue=0;
 };
        pal[63].red=255;
        pal[63].green=255;
        pal[63].blue=255;
 
 for(C=1;C<255;C++)//////
 {
        pal[C].red=C;
        pal[C].green=C;
        pal[C].blue=C;
 };
 
 SV_setPalette(0,256,pal,-1);
};

void tinymap(int x, int y, int uhel)
{
 int C,D;

 paintmap(mapa,x-(TINYMAPSIZE/2),y-(TINYMAPSIZE/2),TINYMAPSIZE,TINYMAPSIZE-1);

 C=(sin[uhel])>>3;
 D=(cos[uhel])>>3;
 SV_line(40,40,40-C,40+D,63);

};

void main()
{
 int C,D,X,Y;

 DC = SV_init(false);
 if (!DC) 
 {
    printf("\n\n FATAL ERROR!!!");
    exit(0);
 };

 if(DC->VBEVersion<0x0200)
 {
    printf("\n\nThis program requires VESA version 2.0 or higher\n");
    printf("Your VESA version is %d.%d.\n",(char)(DC->VBEVersion>>8),(char)DC->VBEVersion);
    printf("Try UniVBE\n");
    exit(0);
 };

 SV_setMode(0x6103,false,false,1);
 setsimpalette(); 
outp(0x3c2,inp(0x3cc)&(255-64)|128);///////////////////////////////////////////////////////////////////////////////
 mapa = (char *) malloc(sizeof(char [MAPSIZE*MAPSIZE]));
 colors = (short int *) malloc(sizeof(short int [MAPSIZE*MAPSIZE]));

 if (mapa==NULL) exit(-1);
 if (colors==NULL) exit(-2);

 srand((unsigned int) time(NULL));

 loadtables();

 for (C=0;C<600;C++) MulTab[C] = DC->bytesperline*C;

 for (C=0;C<MAPSIZE*MAPSIZE;C++) mapa[C]=0;

 for (C=0;C<MAPSIZE;C++) mapa[C]=128;
 for (C=0;C<MAPSIZE;C++) mapa[(MAPSIZE-1)*MAPSIZE + C]=128;
 for (C=0;C<MAPSIZE;C++) mapa[MAPSIZE*C]=128;
 for (C=0;C<MAPSIZE;C++) mapa[MAPSIZE*C+MAPSIZE-1]=128;

 mapa[0] =                       128;
 mapa[MAPSIZE-1] =               128;
 mapa[MAPSIZE*MAPSIZE-MAPSIZE] = 128;
 mapa[MAPSIZE*MAPSIZE-1] =       128;

 plasma(0,0,MAPSIZE-1,MAPSIZE-1);
 makecolors();

 SV_setActivePage(0);
 SV_clear(POZADI);

 SV_setActivePage(1);
 SV_setVisualPage(1,TRUE);
 SV_clear(POZADI);

 for (D=0;D<60;D++) pos[(0<<7)+D]=0;
 for (D=0;D<60;D++) pos[(1<<7)+D]=0;

 for (C=0;C<2048;C++) horizont[C]=600;

 initclocks = clock();

 while (!quit)
 {
     page=page^1;
     SV_setActivePage(page);
     SV_clear(POZADI);

     for (D=0;D<800;D++) horizont[(page<<10)+D]=600;

     getmouse(&dx,&dy,&buttons);

     d_uhel+=dx;
     if(buttons&0x0001) heigth-=dy; else thurst+=dy;

     if (heigth>650) heigth=650;
     if (heigth<250) heigth=250;////////////

     if (d_uhel>300) d_uhel=300;
     if (d_uhel<-300) d_uhel=-300;

     if (thurst>200) thurst=200;
     if (thurst<-200) thurst=-200;

     if (d_uhel>10) d_uhel-=5; else
     if (d_uhel<-10) d_uhel+=5; else d_uhel= d_uhel/2;

     if (thurst>10) thurst-=5; else
     if (thurst<-10) thurst+=5; else thurst= thurst/2;

     uhel=uhel+d_uhel;

     uhel=uhel%(360*16);
     if (uhel<0) uhel+=(360*16);

     posun(map_x, map_y, uhel, thurst, &map_x, &map_y);

     for(D=0;D<60;D++) pos[(page<<7)+D]=0;

     paint(map_x>>4,map_y>>4,uhel>>4,page);
        
     for (D=0;D<800;D++) horizont[(page<<10)+D]=600;

     putbuffer(page);

     tinymap(map_x>>4,map_y>>4,uhel>>4);
     paintsky(&horizont[page<<10]);

     SV_line(0,0,0,600,64);

     frames++;
     fps = frames*100/(clock()-initclocks+1);

     sprintf(S,"FPS: %d",fps);
     SV_writeText(720,10,S,63);/////////////

     SV_setVisualPage(page,FALSE);

     if(DoWait) WaitVRT();
     if(kbhit())
     {
         Key = getch();
         if(Key==0) Key = (getch())<<8;
         switch(Key)
         {
            case 0x1b: quit=1;break;
            case 0x77: {
                           DoWait^=1;
                           frames=0;
                           initclocks=clock();
                       };break;
            case 0x3b00: {   
                            if(DebugPal) { setsimpalette();POZADI = 0xff;}/////////////////////setsimpalette
                            else {setdebugpalette();POZADI=0x00;};
                            DebugPal^=1;
                       };break;
            case 0x3c00: { setdebugpalette();
                       };break;
         };
     };

 };

 for (Y = 0; Y < MAPSIZE - 1; Y++)
 {
  for (X = 0; X < MAPSIZE - 1; X++) SV_putPixel(X,Y,mapa[Y*MAPSIZE+X]>>2);
 }

 getch();
}
